'use strict';

var _electron = require('electron');

var _customUI = require('../customUI');

window.wait(function () {
  var listenNowURL = 'https://play.google.com/music/listen#/now';
  var searchBox = document.querySelector('#material-one-middle > sj-search-box') || document.querySelector('#material-one-middle');
  var searchInput = document.querySelector('sj-search-box input') || document.querySelector('#material-one-middle > input');

  var backBtn = document.createElement('paper-icon-button');
  backBtn.setAttribute('icon', 'arrow-back');
  backBtn.setAttribute('id', 'backButton');
  backBtn.setAttribute('class', 'x-scope paper-icon-button-0');
  searchBox.insertBefore(backBtn, null);

  var canBack = function canBack() {
    return !(location.href.indexOf(listenNowURL) === 0);
  };

  var attemptBack = function attemptBack() {
    var testJs = 'document.querySelector("webview").canGoBack()';
    _electron.remote.getCurrentWindow().webContents.executeJavaScript(testJs, false, function (canGoBack) {
      if (!canBack()) return null;
      if (canGoBack) return history.back();
      location.href = listenNowURL;
    });
  };
  var attemptForward = function attemptForward() {
    var testJs = 'document.querySelector("webview").canGoForward()';
    _electron.remote.getCurrentWindow().webContents.executeJavaScript(testJs, false, function (canGoForward) {
      if (canGoForward) return history.forward();
    });
  };

  backBtn.addEventListener('click', attemptBack);
  window.addEventListener('keyup', function (e) {
    if (e.which === 8 && document.activeElement.value === undefined || e.which === 37 && e.altKey && document.activeElement.value === undefined) {
      attemptBack();
    } else if (e.which === 39 && e.altKey && document.activeElement.value === undefined) {
      attemptForward();
    }
  });

  (0, _customUI.style)('#backButton', {
    position: 'absolute',
    right: '3px',
    top: '1px',
    width: '46px',
    height: '46px',
    opacity: '0',
    transition: 'opacity 0.2s ease-in-out'
  });

  // Make sure the clearSearch button is above the arrow
  (0, _customUI.style)('sj-search-box #clearButton', { 'z-index': 10 });

  // Hide Back button if search box has query
  (0, _customUI.cssRule)('sj-search-box[has-query] #backButton {opacity: 0 !important}');

  var correctButtonVis = function correctButtonVis() {
    backBtn.style.opacity = !canBack() ? 0 : 1;
  };
  window.addEventListener('popstate', correctButtonVis);
  searchInput.addEventListener('input', correctButtonVis);
  correctButtonVis();
});