'use strict';

var _electron = require('electron');

var bWindow = _electron.remote.getCurrentWindow();

var handleAppCommand = function handleAppCommand(e, cmd) {
  if (cmd === 'browser-backward') {
    _electron.remote.getCurrentWebContents().goBack();
  } else if (cmd === 'browser-forward') {
    _electron.remote.getCurrentWebContents().goForward();
  }
};

var handleSwipeCommand = function handleSwipeCommand(e, direction) {
  if (direction === 'left') {
    _electron.remote.getCurrentWebContents.goBack();
  } else if (direction === 'right') {
    _electron.remote.getCurrentWebContents().goForward();
  }
};

window.addEventListener('beforeunload', function () {
  bWindow.removeListener('app-command', handleAppCommand);
  bWindow.removeListener('swipe', handleSwipeCommand);
});
bWindow.on('app-command', handleAppCommand);
bWindow.on('swipe', handleSwipeCommand);

if (process.platform === 'linux') {
  var mouse = require('mouse-forward-back');

  mouse.register(function (button) {
    if (button === 'back') {
      _electron.remote.getCurrentWebContents().goBack();
    } else if (button === 'forward') {
      _electron.remote.getCurrentWebContents().goForward();
    }
  }, _electron.remote.getCurrentWindow().getNativeWindowHandle());
}