'use strict';

var _electron = require('electron');

Emitter.on('error', function (event, details) {
  window.showToast('An uncaught error has occurred inside GPMDP.', false, 'Click here to report this as an issue on GitHub', '#E53935', function (buttonEvent, toast) {
    var title = 'Uncaught Exception: ' + details.error.message.split(/\n/g)[0].substring(0, 100);
    var body = '\nAn uncaught exception was reported.  %0A\n%23%23%23%23 Info:%0A\n**OS:** ' + process.platform + '%0A\n**Arch:** ' + process.arch + '%0A\n**GPMDP Version:** ' + require('../../../../package.json').version + '%0A\n**Time:** ' + new Date() + '%0A\n%0A\n%23%23%23%23 Error:%0A\n*' + details.error.message.split(/\n/g)[0].substring(0, 100) + '*%0A\n```js%0A\n' + details.error.stack.replace(/(?:\r\n|\r|\n)/g, '%0A').substring(0, 1200) + '\n' + (details.error.stack.length > 1200 ? '%0A...Some of the stack is missing' : '') + '%0A\n```\n%0A\nThis issue was created automatically inside the `uncaughtException` handler';
    _electron.remote.shell.openExternal('https://github.com/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-/issues/new?title=' + title + '&body=' + body); // eslint-disable-line
    toast.hide();
    buttonEvent.preventDefault();
    return false;
  }, function () {});
});