'use strict';

var _electron = require('electron');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var mainWindow = _electron.remote.getCurrentWindow();
var webContents = mainWindow.webContents;
var MINI_SIZE = 310;

var mini = false;

window.wait(function () {
  if (Settings.get('miniAlwaysShowSongInfo', false)) {
    document.body.setAttribute('controls', 'controls');
  }

  window.GPM.mini.on('enable', function () {
    Emitter.fire('mini', { state: true });

    // Restore the mini size/position from settings, otherwise use default size and regular position.
    var miniSize = Settings.get('mini-size', [MINI_SIZE, MINI_SIZE]);
    var miniPosition = Settings.get('mini-position', mainWindow.getPosition());
    mainWindow.setSize.apply(mainWindow, _toConsumableArray(miniSize));
    mainWindow.setPosition.apply(mainWindow, _toConsumableArray(miniPosition));

    mainWindow.setMaximumSize(MINI_SIZE, MINI_SIZE);
    webContents.executeJavaScript('document.body.setAttribute("mini", "mini")');
    _electron.remote.getCurrentWebContents().setZoomFactor(1);
    _electron.remote.getCurrentWindow().setAlwaysOnTop(Settings.get('miniAlwaysOnTop', false));
    mini = true;
  });

  window.GPM.mini.on('disable', function () {
    Emitter.fire('mini', { state: false });
    // DEV: Set max size to be massive
    //      Same reason as specified in Electron src
    //        --> https://github.com/atom/electron/blob/master/atom/browser/native_window_views.cc
    mainWindow.setMaximumSize(99999999, 999999999);

    // Restore the regular size/position from settings.
    var regularSize = Settings.get('size');
    var regularPosition = Settings.get('position');
    mainWindow.setSize.apply(mainWindow, _toConsumableArray(regularSize));
    mainWindow.setPosition.apply(mainWindow, _toConsumableArray(regularPosition));

    webContents.executeJavaScript('document.body.removeAttribute("mini", "mini")');
    _electron.remote.getCurrentWebContents().setZoomFactor(1);
    _electron.remote.getCurrentWindow().setAlwaysOnTop(false);
    mini = false;
  });
});

var nextZoom = void 0;
Emitter.on('set:zoom', function (event, factor) {
  if (nextZoom) {
    clearTimeout(nextZoom);
  }
  nextZoom = setTimeout(function () {
    _electron.remote.getCurrentWebContents().setZoomFactor(factor);
  }, 5);
});

Emitter.on('miniAlwaysShowSongInfo', function (event, state) {
  if (state.state) {
    document.body.setAttribute('controls', 'controls');
  } else {
    document.body.removeAttribute('controls');
  }
});
Emitter.on('miniAlwaysOnTop', function (event, state) {
  if (mini) {
    _electron.remote.getCurrentWindow().setAlwaysOnTop(state.state);
  }
});