'use strict';

var pauseAfter = false;

window.addEventListener('load', function () {
  GPM.on('change:song', function () {
    if (pauseAfter) {
      GPM.playback.playPause();
      Emitter.fireAtGoogle('pauseAfter:hide', null);
    }
  });
});

Emitter.on('pauseAfter:show', function () {
  if (!pauseAfter) {
    window.showToast('Pausing after this song.', true, 'Don\'t pause after this song', Settings.get('themeColor'), function (event) {
      Emitter.fireAtGoogle('pauseAfter:hide', null);
      event.preventDefault();
      return false;
    }, function (toast) {
      pauseAfter = true;
      Emitter.on('pauseAfter:hide', function () {
        pauseAfter = false;
        toast.hide();
      });
    });
  }
});