'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (playlistName) {
  return new Promise(function (resolve, reject) {
    if (!playlistName) {
      resolve();return;
    }
    var playlistLinks = document.querySelectorAll('#playlists > a');
    var foundLink = void 0;

    _lodash2.default.forEach(playlistLinks, function (link) {
      var label = link.querySelector('div').innerText;
      if (label.toLowerCase().trim() === playlistName.toLowerCase()) {
        foundLink = link;
      }
    });

    if (foundLink) {
      foundLink.click();
      (0, _waitFor2.default)(function () {
        var title = document.querySelector('.playlist-view .material-container-details .info .title'); // eslint-disable-line
        return title && title.innerText.toLowerCase().trim() === playlistName.toLowerCase();
      }).then(function () {
        document.querySelector('.playlist-view .material-container-details [data-id=play]').click(); // eslint-disable-line
        resolve('');
      });
    } else {
      reject('There is no playlist with the name ' + playlistName);
    }
  });
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _waitFor = require('./waitFor');

var _waitFor2 = _interopRequireDefault(_waitFor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }