'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _audioSelection = require('./audioSelection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.wait(function () {
  var waitForAudio = setInterval(function () {
    if (document.querySelector('audio')) {
      clearInterval(waitForAudio);

      // DEV: We do this here so that we can set the output device before hooking the context
      navigator.mediaDevices.enumerateDevices().then(function (devices) {
        return new Promise(function (resolve) {
          var set = false;
          _lodash2.default.forEach(devices, function (device) {
            if (device.label === Settings.get('audiooutput')) {
              (function () {
                set = true;
                var once = true;
                document.querySelector('audio').addEventListener('playing', function () {
                  if (!once) return;
                  once = false;
                  (0, _audioSelection.setAudioDevice)(device.deviceId).then(resolve);
                });
              })();
            }
          });
          if (!set) resolve();
        });
      }).then(function () {
        // TODO: Uncomment this so that the equalizer works
        // DEV: This doesn't work with audio selection so let's disable it
        // const context = new AudioContext();
        // window.audioFilterContext = context;
        // const mediaElement = document.querySelector('audio');
        // const sourceNode = context.createMediaElementSource(mediaElement);
        // window.audioSourceNode = sourceNode;
        //
        // const GAIN_DB = -40.0;
        // // These are the EQ levels that the android EQ uses
        // const BAND_SPLITS = [60, 230, 910, 4000, 14000];
        //
        // const bands = [];
        //
        // const sum = context.createGain();
        // const mBand = context.createGain();
        //
        // BAND_SPLITS.forEach((UPPER_BAND, index) => {
        //   const band = context.createBiquadFilter();
        //   band.type = (index !== BAND_SPLITS.length - 1 ? 'highshelf' : 'lowshelf');
        //   band.frequency.value = UPPER_BAND;
        //   band.gain.value = GAIN_DB;
        //
        //   const invert = context.createGain();
        //   invert.gain.value = -1.0;
        //   sourceNode.connect(band);
        //   band.connect(invert);
        //   invert.connect(mBand);
        //
        //   const gain = context.createGain();
        //   band.connect(gain);
        //   gain.connect(sum);
        //
        //   gain.gain.value = Settings.get('eq', [1, 1, 1, 1, 1, 1])[bands.length];
        //   bands.push(gain);
        // });
        //
        // sourceNode.connect(mBand);
        //
        // const mGain = context.createGain();
        // mBand.connect(mGain);
        //
        // mGain.connect(sum);
        //
        // sum.connect(context.destination);
        //
        // // TODO: remove
        // window.bands = bands;
        // window.mBand = mBand;
        //
        // Emitter.on('eq:change', (event, details) => {
        //   bands[details.index].gain.value = details.value;
        // });
      });
    }
  }, 10);
});