'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setAudioDevice = undefined;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Emitter.on('audiooutput:fetch', function () {
  navigator.mediaDevices.enumerateDevices().then(function (devices) {
    Emitter.fireAtAll('audiooutput:list', _lodash2.default.transform(devices, function (final, device) {
      final.push({
        deviceId: device.deviceId,
        label: device.label,
        kind: device.kind
      });
    }, []));
  });
});

var setAudioDevice = exports.setAudioDevice = function setAudioDevice(id) {
  var count = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];
  return new Promise(function (resolve, reject) {
    document.querySelectorAll('audio')[0].setSinkId(id).then(function () {
      resolve();
    }).catch(function (oops) {
      if (count > 10000) {
        reject(oops);
      } else {
        setAudioDevice(id, count + 1).then(resolve).catch(function (err) {
          return reject(err);
        });
      }
    }); // eslint-disable-line
  });
};

Emitter.on('audiooutput:set', function (event, deviceId) {
  var once = true;
  if (document.querySelector('audio').paused) {
    document.querySelector('audio').addEventListener('playing', function () {
      if (!once) return;
      once = false;
      setAudioDevice(deviceId);
    });
  } else {
    setAudioDevice(deviceId);
  }
});