'use strict';

var _electron = require('electron');

var mode = void 0;
window.wait(function () {
  mode = window.GMusic.Playback.STOPPED;
  window.GPM.on('change:playback', function (newMode) {
    mode = newMode;
  });
});

Emitter.on('playback:previousTrack', function () {
  window.GPM.playback.rewind();
});

Emitter.on('playback:playPause', function () {
  window.GPM.playback.playPause();
});

Emitter.on('playback:nextTrack', function () {
  window.GPM.playback.forward();
});

Emitter.on('playback:stop', function () {
  if (mode === window.GMusic.Playback.PLAYING) {
    window.GPM.playback.playPause();
  }
});

Emitter.on('playback:thumbsUp', function () {
  if (!_electron.remote.getGlobal('PlaybackAPI').data.song.title) return;
  new Notification('You just liked', { // eslint-disable-line
    body: _electron.remote.getGlobal('PlaybackAPI').data.song.title,
    icon: _electron.remote.getGlobal('PlaybackAPI').data.song.albumArt
  });
  window.GPM.rating.setRating(5);
});

Emitter.on('playback:thumbsDown', function () {
  if (!_electron.remote.getGlobal('PlaybackAPI').data.song.title) return;
  new Notification('You just disliked', { // eslint-disable-line
    body: _electron.remote.getGlobal('PlaybackAPI').data.song.title,
    icon: _electron.remote.getGlobal('PlaybackAPI').data.song.albumArt
  });
  window.GPM.rating.setRating(1);
});

Emitter.on('playback:increaseVolume', function () {
  window.GPM.volume.increaseVolume();
});

Emitter.on('playback:decreaseVolume', function () {
  window.GPM.volume.decreaseVolume();
});