'use strict';

var _electron = require('electron');

var minButton = document.querySelector('#min');
var maxButton = document.querySelector('#max');
var closeButton = document.querySelector('#close');

if (minButton) {
  minButton.addEventListener('click', Emitter.fire.bind(Emitter, 'window:minimize', _electron.remote.getCurrentWindow().id));
}
if (maxButton) {
  maxButton.addEventListener('click', Emitter.fire.bind(Emitter, 'window:maximize', _electron.remote.getCurrentWindow().id));
}
if (closeButton) {
  closeButton.addEventListener('click', function () {
    if (document.getElementById('confirmTray') && window.$ && Settings.get('warnMinToTray', true) && Settings.get('minToTray', true)) {
      if ($('#confirmTray').data('open')) {
        return;
      }
      $('#confirmTray').data('open', true);
      $('#confirmTray').openModal();
      $('#confirmTrayButton').one('click', function () {
        Emitter.fire('window:close', _electron.remote.getCurrentWindow().id);
        $('#confirmTray').data('open', false);
      });
      $('#confirmTrayNeverButton').one('click', function () {
        Emitter.fire('window:close', _electron.remote.getCurrentWindow().id);
        Emitter.fire('settings:set', {
          key: 'warnMinToTray',
          value: false
        });
        $('#confirmTray').data('open', false);
      });
    } else {
      Emitter.fire('window:close', _electron.remote.getCurrentWindow().id);
    }
  });
}