'use strict';

var _electron = require('electron');

var webview = document.querySelector('webview');

if (webview) {
  (function () {
    var once = true;
    webview.addEventListener('did-start-loading', function () {
      if (once) {
        once = false;
        webview.src = Settings.get('lastPage', 'https://play.google.com/music/listen');
        document.body.setAttribute('loading', 'loading');
      }
    });

    var savePage = function savePage(param) {
      var url = param.url || param;
      if (!/https?:\/\/play\.google\.com\/music/g.test(url)) return;
      Emitter.fire('settings:set', {
        key: 'lastPage',
        value: url
      });
    };

    webview.addEventListener('dom-ready', function () {
      setTimeout(function () {
        document.body.removeAttribute('loading');
        webview.focus();
        webview.addEventListener('did-navigate', savePage);
        webview.addEventListener('did-navigate-in-page', savePage);

        var focusWebview = function focusWebview() {
          document.querySelector('webview::shadow object').focus();
        };
        window.addEventListener('beforeunload', function () {
          _electron.remote.getCurrentWindow().removeListener('focus', focusWebview);
        });
        _electron.remote.getCurrentWindow().on('focus', focusWebview);
      }, 700);
    });
  })();
}