'use strict';

require('../rendererEmitter');

require('./core');

var _Settings = require('../../main/utils/Settings');

var _Settings2 = _interopRequireDefault(_Settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

global.Settings = new _Settings2.default();
Settings.uncouple();

require('./' + process.platform);

document.addEventListener('DOMContentLoaded', function () {
  require('./windowThemeHandler');
  setTimeout(function () {
    return require('electron').remote.getCurrentWindow().show();
  }, 100);

  var nativeFrameAtLaunch = Settings.get('nativeFrame');

  document.body.classList.toggle('native-frame', nativeFrameAtLaunch);

  Emitter.on('window:fullscreen', function (event, state) {
    if (nativeFrameAtLaunch) return;
    if (state.state) document.body.classList.add('native-frame');
    if (!state.state) document.body.classList.remove('native-frame');
  });

  document.addEventListener('dragover', function (event) {
    event.preventDefault();
    return false;
  }, false);

  document.addEventListener('drop', function (event) {
    event.preventDefault();
    return false;
  }, false);
});