'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var osVersion = _os2.default.release().split('.');

if (osVersion[0] && parseInt(osVersion[0], 10) > 7) {
  // If we are above windows 7 we can use the system notifications but with
  // the silent flag forced on
  require('../silent_Notification');
} else {
  (function () {
    var NOTIFICATIONS = [];

    /**
     * This class is designed to mock the HTML5 Notification API on windows
     * because the native implementation has annoyed notifcation noises that
     * can't be turned off.
     *
     * This class is intended to follow the API spec here
     * -- https://developer.mozilla.org/en/docs/Web/API/notification
     *
     * This is so it could be used anywhere the actual API is used
     */

    var FakeNotification = function () {
      function FakeNotification(text, options) {
        _classCallCheck(this, FakeNotification);

        /** Instance Properties **/
        this.title = text;
        this.dir = options.dir || null;
        this.lang = options.lang || null;
        this.body = options.body || '';
        this.tag = options.tag || null;
        this.icon = options.icon || null;

        this.data = options;

        NOTIFICATIONS.push(this);
        this._id = NOTIFICATIONS.length;

        Emitter.fire('notify', {
          _id: this._id,
          title: this.title,
          icon: this.icon,
          body: this.body
        });

        /** Instance Event Handlers**/
        this.onclick = null;
        this.onerror = null;
        this.onclose = null;
        this.onshow = null;
      }

      /** Instance Methods **/


      _createClass(FakeNotification, [{
        key: 'close',
        value: function close() {
          Emitter.fire('notify:close', this._id);
        }
      }]);

      return FakeNotification;
    }();

    /** Static Properties **/


    FakeNotification.permission = 'granted';

    /** Static Methods **/
    FakeNotification.requestPermission = function (callback) {
      callback('granted');
    };

    /** Event Handlers -- Cross Thread **/
    // TODO: Implement this event in the notificationPolyfill
    Emitter.on('notification:clicked', function (event, id) {
      if (NOTIFICATIONS[id] && NOTIFICATIONS[id].onclick) {
        NOTIFICATIONS[id].onclick();
      }
    });

    // TODO: Implement this event in the notificationPolyfill
    Emitter.on('notification:error', function (event, details) {
      var id = details.id;
      if (NOTIFICATIONS[id] && NOTIFICATIONS[id].onerror) {
        NOTIFICATIONS[id].onerror(details.error);
      }
    });

    // TODO: Implement this event in the notificationPolyfill
    Emitter.on('notification:closed', function (event, id) {
      if (NOTIFICATIONS[id] && NOTIFICATIONS[id].onclose) {
        NOTIFICATIONS[id].onclose();
      }
    });

    // TODO: Implement this event in the notificationPolyfill
    Emitter.on('notification:showed', function (event, id) {
      if (NOTIFICATIONS[id] && NOTIFICATIONS[id].onshow) {
        NOTIFICATIONS[id].onshow();
      }
    });

    window._Notification = window.Notification;
    window.Notification = FakeNotification;
  })();
}