'use strict';

if (window.$ && window.$.ajax) {
  (function () {
    Emitter.on('theme:updateState', function (event, state) {
      if (!state.state) {
        document.body.removeAttribute('theme');
      } else {
        document.body.setAttribute('theme', 'on');
      }
    });
    Emitter.on('theme:updateType', function (event, type) {
      if (type === 'FULL') {
        document.body.setAttribute('full', 'full');
        document.body.removeAttribute('light');
      } else {
        document.body.removeAttribute('full');
        document.body.setAttribute('light', 'light');
      }
    });

    if (Settings.get('theme')) {
      document.body.setAttribute('theme', 'on');
    }
    if (Settings.get('themeType', 'FULL') === 'FULL') {
      document.body.setAttribute('full', 'full');
    } else {
      document.body.setAttribute('light', 'light');
    }

    var style = $('<style></style>');
    $('body').append(style);
    var redrawTheme = function redrawTheme(customColor) {
      var color = customColor || Settings.get('themeColor');
      var border = '[theme][light] .window-border{border-color:' + color + '}';
      var titleBar = '[theme][light] .title-bar{background:' + color + '}';
      var header = '[theme][light] .dialog .window-title{background:' + color + '}';
      style.html(border + titleBar + header);
      document.body.setAttribute('loaded', 'loaded');
    };
    redrawTheme();
    Emitter.on('theme:updateColor', function (event, customColor) {
      redrawTheme(customColor);
    });
  })();
}