'use strict';

require('./rendererEmitter');

var _electron = require('electron');

var warnOnce = true;

var waitForBody = setInterval(function () {
  if (document.body) {
    (function () {
      clearInterval(waitForBody);
      document.querySelectorAll('.top-bar')[0].setAttribute('style', '-webkit-app-region: drag');
      setInterval(function () {
        if (document.querySelectorAll('header').length) {
          document.querySelectorAll('header')[0].remove();
        }
        if (document.querySelectorAll('footer').length) {
          document.querySelectorAll('footer')[0].remove();
        }
        if (document.querySelectorAll('.masthead').length) {
          document.querySelectorAll('.masthead')[0].remove();
        }
        if (window.location.href.split('api_key').length === 1 && warnOnce) {
          warnOnce = false;
          alert('You appear to have left the authorization process,\n                if this is a mistake, please try authorizing again');
          Emitter.fire('lastfm:auth_result', { result: false });
          _electron.remote.getCurrentWindow().close();
        }
        if (document.querySelectorAll('.alert-success').length) {
          if (document.querySelectorAll('.alert-success')[0].innerHTML.split('granted permission').length > 1) {
            // eslint-disable-line
            Emitter.fire('lastfm:auth_result', { result: true });
            _electron.remote.getCurrentWindow().close();
          }
        }
      }, 10);
      _electron.remote.getCurrentWindow().show();
      var checkForForm = setInterval(function () {
        var submits = document.querySelectorAll('button[type=submit]');
        [].forEach.call(submits, function (submit) {
          if (submit.classList.contains('btn-primary') && submit.name === 'confirm') {
            clearInterval(checkForForm);
            document.querySelector('button[type=submit] + a').addEventListener('click', function (e) {
              e.preventDefault();
              Emitter.fire('lastfm:auth_result', { result: false });
              _electron.remote.getCurrentWindow().close();
              return false;
            });
          }
        });
      }, 100);
    })();
  }
}, 10);