'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _electron = require('electron');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Emitter = function () {
  function Emitter() {
    var _this = this;

    _classCallCheck(this, Emitter);

    var ready = true;
    this.__defineGetter__('ready', function () {
      return ready;
    });
    this.__defineSetter__('ready', function (newValue) {
      ready = newValue;
      if (newValue) {
        _this.q.forEach(function (fn) {
          fn();
        });
        _this.q = [];
      }
    });
    this.q = [];

    _electron.ipcRenderer.on('execute', function (event, details) {
      if (details && details.fn) {
        _electron.remote.getCurrentWebContents().executeJavaScript(details.fn);
      } else {
        Logger.warn('Function not passed to the execute event');
      }
    });

    _electron.ipcRenderer.on('passthrough', function (event, details) {
      var view = document.querySelector('webview');
      if (!view) {
        Logger.warn('Attempting to pass event through to WebView, but no WebView found', details);
        return;
      }
      if (details && details.event) {
        if (view.isLoading()) {
          (function () {
            var waitForPageLoad = 0;
            view.addEventListener('did-stop-loading', function () {
              if (waitForPageLoad > 1 && !view.isLoading()) {
                view.send(details.event, details.details);
              }
              waitForPageLoad++;
            });
          })();
        } else {
          view.send(details.event, details.details);
        }
      }
    });
  }

  _createClass(Emitter, [{
    key: 'fire',
    value: function fire(event, details) {
      if (this.ready) {
        _electron.ipcRenderer.send(event, details);
      } else {
        this.q.push(this.fire.bind(this, event, details));
      }
    }
  }, {
    key: 'fireAtAll',
    value: function fireAtAll(event, details) {
      if (this.ready) {
        _electron.ipcRenderer.send('passback:all', {
          event: event,
          details: details
        });
        _electron.ipcRenderer.send(event, details);
      } else {
        this.q.push(this.fireAtAll.bind(this, event, details));
      }
    }
  }, {
    key: 'fireAtMain',
    value: function fireAtMain(event, details) {
      if (this.ready) {
        _electron.ipcRenderer.send('passback:main', {
          event: event,
          details: details
        });
      } else {
        this.q.push(this.fireAtMain.bind(this, event, details));
      }
    }
  }, {
    key: 'fireAtGoogle',
    value: function fireAtGoogle(event, details) {
      if (this.ready) {
        _electron.ipcRenderer.send('passback', {
          event: event,
          details: details
        });
      } else {
        this.q.push(this.fireAtGoogle.bind(this, event, details));
      }
    }
  }, {
    key: 'on',
    value: function on(event, fn) {
      var _this2 = this;

      _electron.ipcRenderer.on(event, function (internalEvent, internalDetails) {
        if (_this2.ready) {
          _this2._call(fn, internalEvent, internalDetails);
        } else {
          _this2.q.push(_this2._call.bind(_this2, fn, internalEvent, internalDetails));
        }
      });
    }
  }, {
    key: '_call',
    value: function _call(fn, internalEvent, internalDetails) {
      fn(internalEvent, internalDetails);
    }
  }]);

  return Emitter;
}();

global.Emitter = new Emitter();