'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var devices = void 0;

Emitter.on('audiooutput:list', function (event, d) {
  devices = d;
  $('#audioOutputSelect option').remove();
  devices.forEach(function (device) {
    if (device.kind === 'audiooutput') {
      var label = device.label;
      if (!label) {
        switch (device.deviceId) {
          case 'default':
            label = 'System Default';
            break;
          case 'communications':
            label = 'System Default Communications';
            break;
          default:
            label = 'Unknown Device';
            break;
        }
      }
      var opt = $('<option></option>');
      opt.attr('value', device.deviceId);
      opt.text(label);
      if (label === Settings.get('audiooutput')) {
        opt.attr('selected', true);
      }
      $('#audioOutputSelect').append(opt);
    }
  });
  $('select').material_select();
  $('.dropdown-content li>a, .dropdown-content li>span').addClass('theme-text');
});

Emitter.fireAtGoogle('audiooutput:fetch');

$('#audioOutputSelect').on('change', function (e) {
  Emitter.fireAtGoogle('audiooutput:set', $(e.currentTarget).val());
  var label = _lodash2.default.find(devices, function (device) {
    return device.deviceId === $(e.currentTarget).val();
  }).label;
  Emitter.fire('audiooutput:set', label);
});

var currentSelected = Settings.get('audiooutput');
setInterval(function () {
  if (currentSelected !== Settings.get('audiooutput')) {
    currentSelected = Settings.get('audiooutput');
    $('#audioOutputSelect option').each(function (index, opt) {
      if ($(opt).text() === currentSelected) {
        $('#audioOutputSelect').val($(opt).attr('value'));
        $('#audioOutputSelect').material_select();
      }
    });
  }
}, 500);