'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ACCELERATOR_KEYS = {
  17: 'Ctrl'
};

var MODIFIER_KEYS = {
  16: 'Shift',
  18: 'Alt'
};

var ACTION_KEYS = _lodash2.default.transform(_lodash2.default.range(26), function (final, current) {
  final[current + 65] = String.fromCharCode(current + 65); // eslint-disable-line
}, {
  37: 'Left',
  38: 'Up',
  39: 'Right',
  40: 'Down'
});

var initialHotkeys = Settings.get('hotkeys', {});

var writeAccelerator = function writeAccelerator(input) {
  if (input.data('a')) {
    var a = input.data('a');
    var m = input.data('m') || [];
    var ac = input.data('ac') || [];
    m.sort();
    ac.sort();

    if (ac.length !== 0) {
      if (m.length !== 0) {
        input.val([a, m.join('+'), ac.join('+')].join('+'));
      } else {
        input.val([a, ac.join('+')].join('+'));
      }
    }
  } else if (input.data('reset')) {
    input.data('reset', false);
    input.data('a', null);
    input.data('m', []);
    input.data('ac', []);
    input.val('Not Set');
  }
};

// DEV: Lets by honest this looks awful, need to clean this up.......
$('#hotkeys input').on('keydown', function (e) {
  var input = $(e.currentTarget);
  var m = input.data('m') || [];
  var ac = input.data('ac') || [];

  if (ACCELERATOR_KEYS[e.which]) {
    input.data('a', ACCELERATOR_KEYS[e.which]);
  } else if (MODIFIER_KEYS[e.which] && !_lodash2.default.includes(m, MODIFIER_KEYS[e.which])) {
    input.data('m', m.concat([MODIFIER_KEYS[e.which]]));
  } else if (ACTION_KEYS[e.which] && !_lodash2.default.includes(ac, ACTION_KEYS[e.which])) {
    input.data('ac', ac.concat([ACTION_KEYS[e.which]]));
  }
  writeAccelerator(input);
  e.preventDefault();
  return false;
}).on('keyup', function (e) {
  var input = $(e.currentTarget);
  var m = input.data('m') || [];
  var ac = input.data('ac') || [];

  if (ACCELERATOR_KEYS[e.which]) {
    input.data('a', null);
  } else if (MODIFIER_KEYS[e.which]) {
    _lodash2.default.remove(m, function (val) {
      return val === MODIFIER_KEYS[e.which];
    });
    input.data('m', m);
  } else if (ACTION_KEYS[e.which]) {
    _lodash2.default.remove(ac, function (val) {
      return val === ACTION_KEYS[e.which];
    });
    input.data('ac', ac);
  } else if (e.which === 27) {
    input.data('reset', true);
  }
  writeAccelerator(input);
  Emitter.fire('hotkey:set', {
    action: input.attr('id'),
    accelerator: input.val() === 'Not Set' ? null : input.val()
  });
}).each(function (index, el) {
  var input = $(el);
  input.val(initialHotkeys[input.attr('id')] || 'Not Set');
});