'use strict';

var styleSwitch = document.querySelector('#themeStyleSwitch');
var styleSwitchCheckbox = document.querySelector('#themeStyleSwitch input');

$('.color-square').click(function (e) {
  var newColor = $(e.currentTarget).css('background-color');
  Emitter.fire('theme:updateColor', newColor);
});

$('#theme-state').change(function (e) {
  var state = $(e.currentTarget).is(':checked');
  Emitter.fire('theme:updateState', { state: state });
  if (state) {
    styleSwitch.style.display = 'block';
  } else {
    styleSwitch.style.display = 'none';
  }
});
$(styleSwitchCheckbox).change(function (e) {
  var state = $(e.currentTarget).is(':checked');
  Emitter.fire('theme:updateType', state ? 'FULL' : 'HIGHLIGHT_ONLY');
});

if (Settings.get('theme', false)) {
  $('#theme-state').attr('checked', true);
} else {
  $('#theme-state').removeAttr('checked');
  styleSwitch.style.display = 'none';
}
styleSwitchCheckbox.checked = Settings.get('themeType', 'FULL') === 'FULL'; // eslint-disable-line

$('#color_wheel_trigger').click(function () {
  Emitter.fire('window:color_wheel');
});