'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _electron = require('electron');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var screenSize = _electron.screen.getPrimaryDisplay().workAreaSize;
  var defaultHeight = screenSize.height * 3 / 4;
  var defaultWidth = screenSize.width * 3 / 4;

  var baseConfig = {
    width: Settings.get('width', defaultWidth),
    height: Settings.get('height', defaultHeight),
    x: Settings.get('X'),
    y: Settings.get('Y'),
    show: false,
    autoHideMenuBar: true,
    frame: Settings.get('nativeFrame'),
    icon: _path2.default.resolve(__dirname + '/../assets/img/main.' + (process.platform === 'win32' ? 'ico' : 'png')), // eslint-disable-line
    title: 'Google Play Music Desktop Player',
    webPreferences: {
      nodeIntegration: true,
      preload: _path2.default.resolve(__dirname + '/../inject/generic/index.js')
    }
  };

  return baseConfig;
};