'use strict';

Emitter.on('window:minimize', function (event, windowID) {
  WindowManager.getByInternalID(windowID).minimize();
});

Emitter.on('window:maximize', function (event, windowID) {
  var window = WindowManager.getByInternalID(windowID);
  if (window.isMaximized()) {
    WindowManager.getByInternalID(windowID).unmaximize();
  } else {
    WindowManager.getByInternalID(windowID).maximize();
  }
});

Emitter.on('window:close', function (event, windowID) {
  var winToClose = WindowManager.getByInternalID(windowID);
  if (winToClose) {
    winToClose.close();
  }
});

var mainWindow = WindowManager.getAll('main')[0];
mainWindow.on('close', function (event) {
  if ((Settings.get('minToTray', true) || process.platform === 'darwin') && !global.quiting) {
    if (process.platform !== 'darwin') {
      mainWindow.minimize();
      mainWindow.setSkipTaskbar(true);
    } else {
      if (PlaybackAPI.isPlaying() && !Settings.get('minToTray', true)) {
        Emitter.sendToGooglePlayMusic('playback:playPause');
      }
      mainWindow.hide();
    }
    event.preventDefault();
    return;
  }
});