'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _htmlEntities = require('html-entities');

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _xss = require('xss');

var _xss2 = _interopRequireDefault(_xss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var decoder = new _htmlEntities.AllHtmlEntities();

var attemptLyricsWikia = function attemptLyricsWikia(path) {
  return new Promise(function (resolve, reject) {
    (0, _nodeFetch2.default)('http://lyrics.wikia.com/wiki/' + path).then(function (data) {
      return data.text();
    }).then(function (html) {
      var lyrics = /('|")lyricbox('|")>(.+<\/script>)?(.+)<!--/g.exec(html)[4];
      lyrics = lyrics.replace(/<br \/>/gi, '\n');
      lyrics = decoder.decode(lyrics);
      lyrics = (0, _xss2.default)(lyrics, {
        whiteList: { br: [], i: [], b: [], strong: [], em: [] },
        stripIgnoreTag: true,
        stripIgnoreTagBody: ['script']
      });
      resolve(lyrics);
    }).catch(reject);
  });
};

exports.default = attemptLyricsWikia;