'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _htmlEntities = require('html-entities');

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _xss = require('xss');

var _xss2 = _interopRequireDefault(_xss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var decoder = new _htmlEntities.AllHtmlEntities();

var attemptMetroLyrics = function attemptMetroLyrics(path) {
  return new Promise(function (resolve, reject) {
    (0, _nodeFetch2.default)('http://www.metrolyrics.com/' + path + '.html').then(function (data) {
      return data.text();
    }).then(function (html) {
      var lyricsChunk = /('|")lyrics-body('|")>([\s\S]+)('|")lyrics-bottom('|")/gm.exec(html)[3]; // eslint-disable-line
      var lyrics = '';
      var paraRegexp = /<p class=('|")verse('|")>([\s\S]+?)<\/p>/g;
      var paragraph = paraRegexp.exec(lyricsChunk);
      while (paragraph) {
        lyrics += paragraph[3] + '{{PARA}}';
        paragraph = paraRegexp.exec(lyricsChunk);
      }
      lyrics = lyrics.replace(/\r?\n|\r/g, '');
      lyrics = lyrics.replace(/<br ?\/?>/gi, '\n');
      lyrics = lyrics.replace(/\{\{PARA\}\}/gi, '\n\n');
      lyrics = decoder.decode(lyrics);
      lyrics = (0, _xss2.default)(lyrics, {
        whiteList: { br: [], i: [], b: [], strong: [], em: [] },
        stripIgnoreTag: true,
        stripIgnoreTagBody: ['script']
      });
      resolve(lyrics);
    }).catch(reject);
  });
};

exports.default = attemptMetroLyrics;