'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _htmlEntities = require('html-entities');

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _xss = require('xss');

var _xss2 = _interopRequireDefault(_xss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var decoder = new _htmlEntities.AllHtmlEntities();

var attemptMusiXmatch = function attemptMusiXmatch(path) {
  return new Promise(function (resolve, reject) {
    (0, _nodeFetch2.default)('https://www.musixmatch.com/search/' + path) // the lyrics urls aren't always very straightforward...
    .then(function (data) {
      return data.text();
    }).then(function (searchHtml) {
      var searchReturn = JSON.parse(/__mxmProps = ({.+})<\/script>/.exec(searchHtml)[1]);
      (0, _nodeFetch2.default)(searchReturn.allResults.bestMatch.shareURI).then(function (data) {
        return data.text();
      }).then(function (lyricsHtml) {
        var lyricsReturn = JSON.parse(/__mxmState = ({.+});<\/script>/.exec(lyricsHtml)[1]);
        var lyrics = void 0;
        if (lyricsReturn.page.lyrics.lyrics.instrumental) {
          lyrics = 'INSTRUMENTAL';
        } else {
          lyrics = lyricsReturn.page.lyrics.lyrics.body;
        }
        lyrics = decoder.decode(lyrics);
        lyrics = (0, _xss2.default)(lyrics, {
          whiteList: { br: [], i: [], b: [], strong: [], em: [] },
          stripIgnoreTag: true,
          stripIgnoreTagBody: ['script']
        });
        resolve(lyrics);
      }).catch(reject);
    }).catch(reject);
  });
};

exports.default = attemptMusiXmatch;