'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var mainWindows = WindowManager.getAll('main');
var mainWindow = mainWindows[0];

var mini = false;
Emitter.on('mini', function (event, state) {
  mini = state.state;
});

var resizeTimer = void 0;

var _save = function _save() {
  if (!mini) {
    if (mainWindow.isMaximized()) {
      Settings.set('maximized', true);
    } else {
      Settings.set('maximized', false);
      Settings.set('position', mainWindow.getPosition());
      Settings.set('size', mainWindow.getSize());
    }
  } else {
    (function () {
      Settings.set('mini-position', mainWindow.getPosition());
      Settings.set('mini-size', mainWindow.getSize());

      // Keep the mini-player square.
      var dimension = Math.max.apply(Math, _toConsumableArray(mainWindow.getSize()));
      if (resizeTimer) clearTimeout(resizeTimer);
      resizeTimer = setTimeout(function () {
        return mainWindow.setSize(dimension, dimension);
      }, 100);
      Emitter.sendToGooglePlayMusic('set:zoom', dimension / 310);
    })();
  }
};

mainWindow.on('move', _save);
mainWindow.on('resize', _save);
mainWindow.on('maximize', function (ev) {
  if (mini) {
    mainWindow.unmaximize();
    ev.preventDefault();
    return false;
  }
  _save();
});
mainWindow.on('unmaximize', _save);

Emitter.on('eq:change', function (event, details) {
  var eq = Settings.get('eq', [1, 1, 1, 1, 1, 1]);
  eq[details.index] = details.value;
  Settings.set('eq', eq);
});

Emitter.on('audiooutput:set', function (event, name) {
  Settings.set('audiooutput', name);
});

Emitter.on('welcomed', function (event, version) {
  Settings.set('welcomed', version);
});