'use strict';

var _dbus = require('dbus');

var _dbus2 = _interopRequireDefault(_dbus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function registerBindings(desktopEnv, session) {
  session.getInterface('org.' + desktopEnv + '.SettingsDaemon', '/org/' + desktopEnv + '/SettingsDaemon/MediaKeys', 'org.' + desktopEnv + '.SettingsDaemon.MediaKeys', function (err, iface) {
    if (!err) {
      iface.on('MediaPlayerKeyPressed', function (n, keyName) {
        switch (keyName) {
          case 'Next':
            Emitter.sendToGooglePlayMusic('playback:nextTrack');return;
          case 'Previous':
            Emitter.sendToGooglePlayMusic('playback:previousTrack');return;
          case 'Play':
            Emitter.sendToGooglePlayMusic('playback:playPause');return;
          case 'Stop':
            Emitter.sendToGooglePlayMusic('playback:stop');return;
          default:
            return;
        }
      });
      iface.GrabMediaPlayerKeys(0, 'org.' + desktopEnv + '.SettingsDaemon.MediaKeys'); // eslint-disable-line
    }
  });
}

try {
  var dbus = new _dbus2.default();
  var session = dbus.getBus('session');

  registerBindings('gnome', session);
  registerBindings('mate', session);
} catch (e) {
  // do nothing.
}