'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _electron = require('electron');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NOTIFICATION_DURATION = 3000;

// TODO: Document this, looking at it now even I don't really get it...

var Notification = function () {
  function Notification(text, options) {
    var _this = this;

    _classCallCheck(this, Notification);

    this.options = options;
    this.window = new _electron.BrowserWindow({
      x: 0,
      y: 0,
      useContentSize: true,
      show: false,
      autoHideMenuBar: true,
      frame: false,
      resizable: false,
      skipTaskbar: true,
      alwaysOnTop: true,
      backgroundColor: '#FFF',
      webPreferences: {
        nodeIntegration: true,
        preload: _path2.default.resolve('./build/inject/generic/index.js')
      }
    });

    this.window.loadURL('file://' + _path2.default.resolve(__dirname + '/../../../public_html/notify.html'));

    var windowID = WindowManager.add(this.window, 'notify');
    Emitter.executeOnWindow(windowID, function (opts) {
      window.NOTIFY_DATA = opts;
    }, this.options);

    setTimeout(function () {
      _this.close();
    }, NOTIFICATION_DURATION);
  }

  _createClass(Notification, [{
    key: 'close',
    value: function close() {
      if (this.window && this.window.close) {
        try {
          this.window.close();
          this.window = null;
        } catch (e) {
          // Do nothing, this is just to ensure that errors aren't thrown on
          // notification race conditions
        }
      }
    }
  }]);

  return Notification;
}();

var currentNotification = void 0;
var notifyInProgress = false;
var queue = [];
var handleNotify = function handleNotify(event, notificationConfig) {
  notifyInProgress = true;
  if (currentNotification) {
    currentNotification.close();
    currentNotification = null;
  }
  currentNotification = new Notification(notificationConfig.title, notificationConfig);
  if (queue.length === 0) {
    notifyInProgress = false;
  } else {
    queue[0]();
  }
};

Emitter.on('notify', function (event, notificationConfig) {
  if (notifyInProgress) {
    queue.push(handleNotify.bind(undefined, event, notificationConfig));
  }
  handleNotify(event, notificationConfig);
});

Emitter.on('notify:close', function (event, _id) {
  if (_lodash2.default.get(currentNotification, 'options._id') === _id) {
    currentNotification.close();
    currentNotification = null;
  }
});