'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var browser = WindowManager.getAll('main')[0];
var resetThumbbarButtons = function resetThumbbarButtons(isPlaying) {
  browser.setThumbarButtons([{
    tooltip: 'Previous Track',
    icon: _path2.default.resolve(__dirname + '/../../../assets/img/media_controls/previous.png'),
    click: Emitter.sendToGooglePlayMusic.bind(Emitter, 'playback:previousTrack')
  }, {
    tooltip: isPlaying ? 'Pause' : 'Play',
    icon: _path2.default.resolve(__dirname + '/../../../assets/img/media_controls/' + (isPlaying ? 'pause' : 'play') + '.png'), // eslint-disable-line
    click: Emitter.sendToGooglePlayMusic.bind(Emitter, 'playback:playPause')
  }, {
    tooltip: 'Next Track',
    icon: _path2.default.resolve(__dirname + '/../../../assets/img/media_controls/next.png'),
    click: Emitter.sendToGooglePlayMusic.bind(Emitter, 'playback:nextTrack')
  }]);
};
// DEV: For some reason we need to wait till focus before setting the thumbbarButtons
browser.once('focus', function () {
  resetThumbbarButtons(false);
});

PlaybackAPI.on('change:state', function (newState) {
  resetThumbbarButtons(newState);
});