'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _electron = require('electron');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Emitter = function () {
  function Emitter() {
    var _this = this;

    _classCallCheck(this, Emitter);

    _electron.ipcMain.on('passback', function (event, details) {
      _this.sendToGooglePlayMusic(details.event, details.details);
    });

    _electron.ipcMain.on('passback:main', function (event, details) {
      _this.sendToWindowsOfName('main', details.event, details.details);
    });

    _electron.ipcMain.on('passback:all', function (event, details) {
      _this.sendToAll(details.event, details.details);
    });
  }

  _createClass(Emitter, [{
    key: '_send',
    value: function _send(window, event, details) {
      var _this2 = this;

      if (window.webContents.isLoading()) {
        (function () {
          var once = false;
          window.webContents.on('did-stop-loading', function () {
            if (!once) {
              once = true;
              _this2._send(window, event, details);
            }
          });
        })();
      } else {
        window.webContents.send(event, details || {});
      }
    }
  }, {
    key: 'sendToWindow',
    value: function sendToWindow(windowID, event, details) {
      var window = WindowManager.get(windowID);
      if (window) {
        this._send(window, event, details);
      }
    }
  }, {
    key: 'sendToWindowsOfName',
    value: function sendToWindowsOfName(name, event, details) {
      var _this3 = this;

      var windows = WindowManager.getAll(name);
      _lodash2.default.forEach(windows, function (window) {
        if (window) {
          _this3._send(window, event, details);
        }
      });
    }
  }, {
    key: 'sendToAll',
    value: function sendToAll(event, details) {
      var _this4 = this;

      _lodash2.default.forIn(WindowManager.IDMap, function (index, ID) {
        var window = WindowManager.getByInternalID(ID);
        if (window) {
          _this4._send(window, event, details);
        }
      });
    }
  }, {
    key: 'sendToGooglePlayMusic',
    value: function sendToGooglePlayMusic(event, details) {
      this.sendToWindowsOfName('main', 'passthrough', {
        event: event,
        details: details
      });
    }
  }, {
    key: 'executeOnWindow',
    value: function executeOnWindow(windowID, fn) {
      var fnString = fn.toString();

      for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      fnString = '(' + fnString + ').apply(window, ' + JSON.stringify(args) + ')';
      this.sendToWindow(windowID, 'execute', {
        fn: fnString
      });
    }
  }, {
    key: 'on',
    value: function on(what, fn) {
      _electron.ipcMain.on(what, fn);
    }
  }, {
    key: 'once',
    value: function once(what, fn) {
      _electron.ipcMain.once(what, fn);
    }
  }]);

  return Emitter;
}();

exports.default = Emitter;