'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _child_process = require('child_process');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var I3IpcHelper = function () {
  function I3IpcHelper() {
    _classCallCheck(this, I3IpcHelper);
  }

  _createClass(I3IpcHelper, [{
    key: 'isI3',
    value: function isI3() {
      return WindowManager.getWindowManagerName() === 'i3';
    }
  }, {
    key: '_hasI3Msg',
    value: function _hasI3Msg(callback) {
      if (this.isI3()) {
        (0, _child_process.exec)('command -v i3-msg', function (error) {
          // we'll get a non 0 exit code if the command doesn't exist
          // this should work on any POSIX compatible shell
          callback(error === null);
        });
      }
      return false;
    }
  }, {
    key: '_getWindowTitleRegex',
    value: function _getWindowTitleRegex() {
      var title = WindowManager.get(global.mainWindowID).getTitle();
      return '^' + title + '$';
    }
  }, {
    key: '_escapeShellArg',
    value: function _escapeShellArg(str) {
      return str.replace(/'/g, "\\'").replace(/"/g, '\\"');
    }
  }, {
    key: 'setFloating',
    value: function setFloating(mode) {
      var _this = this;

      this._hasI3Msg(function (hasMsg) {
        if (hasMsg) {
          var title = _this._escapeShellArg(_this._getWindowTitleRegex());
          var floatingMode = mode ? 'enable' : 'disable';
          (0, _child_process.exec)('i3-msg \'[title="' + title + '"] floating ' + floatingMode + '\'', function () {});
        }
      });
    }
  }, {
    key: 'setupEventListener',
    value: function setupEventListener() {
      var _this2 = this;

      Emitter.on('mini', function (event, eventArguments) {
        _this2.setFloating(eventArguments.state);
      });
    }
  }]);

  return I3IpcHelper;
}();

exports.default = I3IpcHelper;