'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _initialSettings = require('./_initialSettings');

var _initialSettings2 = _interopRequireDefault(_initialSettings);

var _jsonCreator = require('./_jsonCreator');

var _jsonCreator2 = _interopRequireDefault(_jsonCreator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Settings = function () {
  function Settings(jsonPrefix, wipeOldData) {
    _classCallCheck(this, Settings);

    this.PATH = (0, _jsonCreator2.default)((jsonPrefix || '') + '.settings');
    this.data = Object.assign({}, _initialSettings2.default);
    this.lastSync = 0;

    if (_fs2.default.existsSync(this.PATH) && !wipeOldData) {
      this._load();
    } else {
      this._save(true);
      // DEV: Handle windows users running as admin...
      _fs2.default.chmodSync(this.PATH, '777');
    }
    this.coupled = true;
  }

  _createClass(Settings, [{
    key: 'uncouple',
    value: function uncouple() {
      this.coupled = false;
    }
  }, {
    key: 'get',
    value: function get(key) {
      var defaultValue = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

      if (!this.coupled) {
        this._load();
      }
      return typeof this.data[key] === 'undefined' ? defaultValue : this.data[key];
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      if (this.coupled) {
        this.data[key] = value;
        this._save();
      }
    }
  }, {
    key: '_load',
    value: function _load() {
      var userSettings = JSON.parse(_fs2.default.readFileSync(this.PATH, 'utf8'));
      this.data = _lodash2.default.extend({}, _initialSettings2.default, userSettings);
    }
  }, {
    key: '_save',
    value: function _save(force) {
      var now = new Date().getTime();
      // During some save events (like resize) we need to queue the disk writes
      // so that we don't blast the disk every millisecond
      if (now - this.lastSync > 250 || force) {
        if (this.data) _fs2.default.writeFileSync(this.PATH, JSON.stringify(this.data, null, 4));
        if (this.saving) clearTimeout(this.saving);
      } else {
        if (this.saving) clearTimeout(this.saving);
        this.saving = setTimeout(this._save.bind(this), 275);
      }
      this.lastSync = now;
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.data = null;
      _fs2.default.unlinkSync(this.PATH);
    }
  }]);

  return Settings;
}();

exports.default = Settings;