'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WindowManager = function () {
  function WindowManager() {
    _classCallCheck(this, WindowManager);

    this.windows = {};
    this.nameReferences = {};
    this.IDMap = {};

    this.focus = [null];
  }

  _createClass(WindowManager, [{
    key: 'add',
    value: function add(window) {
      var _this = this;

      var name = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

      var newID = Symbol();
      this.windows[newID] = window;
      this.IDMap[window.id] = newID;
      window.on('closed', function () {
        delete _this.windows[newID];
      });
      window.on('focus', function () {
        var focusIndex = _lodash2.default.findLastIndex(_this.focus, function (win) {
          return win !== null;
        });
        if (focusIndex && focusIndex >= 0 && _this.focus[focusIndex].id !== window.id) {
          _this.focus[focusIndex].focus();
        }
      });
      if (name) {
        this.nameReferences[name] = this.nameReferences[name] || [];
        this.nameReferences[name].push(newID);
      }
      return newID;
    }
  }, {
    key: 'get',
    value: function get(windowID) {
      return this.windows[windowID] || null;
    }
  }, {
    key: 'getByInternalID',
    value: function getByInternalID(internalID) {
      if (this.IDMap[internalID]) {
        return this.windows[this.IDMap[internalID]] || null;
      }
      return null;
    }
  }, {
    key: 'getAll',
    value: function getAll(name) {
      var _this2 = this;

      var toReturn = [];
      _lodash2.default.forEach(this.nameReferences[name] || [], function (ID) {
        if (_this2.get(ID)) {
          toReturn.push(_this2.get(ID));
        }
      });
      return toReturn;
    }
  }, {
    key: 'forceFocus',
    value: function forceFocus(window) {
      var _this3 = this;

      var index = this.focus.length;
      this.focus.push(window);
      window.on('close', function () {
        _this3.focus[index] = null;
      });
    }
  }, {
    key: 'close',
    value: function close(windowID) {
      if (this.windows[windowID]) {
        this.windows[windowID].close();
      }
    }
  }, {
    key: 'getWindowManagerName',
    value: function getWindowManagerName() {
      if (process.platform === 'linux') {
        return 'undefined'
      }
      return undefined;
    }
  }]);

  return WindowManager;
}();

exports.default = WindowManager;