'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _electron = require('electron');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _child_process = require('child_process');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var run = function run(args, done) {
  var updateExe = _path2.default.resolve(_path2.default.dirname(process.execPath), '..', 'Update.exe');
  (0, _child_process.spawn)(updateExe, args, {
    detached: true
  }).on('close', done);
};

var handleStartupEvent = function handleStartupEvent() {
  if (process.platform !== 'win32') {
    return false;
  }

  var squirrelCommand = process.argv[1];

  var target = _path2.default.basename(process.execPath);

  switch (squirrelCommand) {
    case '--squirrel-install':
      // Optionally do things such as:
      //
      // - Install desktop and start menu shortcuts
      // - Add your .exe to the PATH
      // - Write to the registry for things like file associations and
      //   explorer context menus
      run(['--createShortcut=' + target], _electron.app.quit);
      return true;
    case '--squirrel-updated':
      run(['--createShortcut=' + target], _electron.app.quit);
      return true;
    case '--squirrel-uninstall':
      // Undo anything you did in the --squirrel-install and
      // --squirrel-updated handlers

      run(['--removeShortcut=' + target], _electron.app.quit);
      return true;
    case '--squirrel-obsolete':
      // This is called on the outgoing version of your app before
      // we update to the new version - it's the opposite of
      // --squirrel-updated
      _electron.app.quit();
      return true;
    default:
      return false;
  }
};

exports.default = handleStartupEvent;